/**
 * The IPAddress model module.
 * @module Ntnx/IPAddress
 * @version 4.0.1
 * @class IPAddress
 */
export default class IPAddress {
    /**
     * Constructs a <code>IPAddress</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:Ntnx/IPAddress} obj Optional instance to populate.
     * @param callFromChild {Boolean} Flag to recognise calling instance
     * @return {module:Ntnx/IPAddress} The populated <code>IPAddress</code> instance.
     */
    static constructFromObject(data: any, obj?: any, callFromChild?: boolean): any;
    /**
    * Converts a given snake_case string to camelCase.
    * @param {string} snakeStr - The input string in snake_case format.
    * @returns {string} - The converted string in camelCase format.
    */
    static snakeToCamel(snakeStr: string): string;
    $objectType: string;
    /** @type {object<string, any>} */
    $reserved: object;
    /** @type {object<string, any>} */
    $unknownFields: object;
    /**
     * @return {IPv4Address}
     */
    getIpv4(): IPv4Address;
    /**
     * @param {IPv4Address} ipv4
     */
    setIpv4(ipv4: IPv4Address): void;
    ipv4: IPv4Address;
    /**
     * @return {IPv6Address}
     */
    getIpv6(): IPv6Address;
    /**
     * @param {IPv6Address} ipv6
     */
    setIpv6(ipv6: IPv6Address): void;
    ipv6: IPv6Address;
    get$Reserved(): any;
    get$ObjectType(): string;
    get$UnknownFields(): any;
    hasIpv4(): boolean;
    hasIpv6(): boolean;
    isValid(): boolean;
    toJson(forMutation: any): {
        $reserved: any;
        $objectType: string;
        $unknownFields: any;
        ipv6?: {
            $reserved: any;
            $objectType: string;
            $unknownFields: any;
            prefixLength?: number;
            value?: string;
        };
        ipv4?: {
            $reserved: any;
            $objectType: string;
            $unknownFields: any;
            prefixLength?: number;
            value?: string;
        };
    };
    validate(scope: any, properties: any, ...args: any[]): Promise<any>;
    validateProperty(scope: any, property: any): ValidationError;
    #private;
}
import IPv4Address from "./IPv4Address";
import IPv6Address from "./IPv6Address";
import ValidationError from "../../../validation/ValidationError";
